#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define size 2		//説明変数の数
#define Number 100


void matrix_multi( double x[size][size] , double y[size][size] , double z[size][size]){
	int i ,j, k;
	
	for(i=0; i<size; i++){
		for(j=0 ; j< size; j++){
			z[i][j] = 0.0;
			for(k=0;k<size ; k++){
				z[i][j] += x[i][k] * y[k][j];
			}
		}
	}
}

int matrix_inv( double x[size][size] , double inv[size][size]){
	double tmp;
	int i,j,pivot;
	double max;
	int max_row;
	
	
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			inv[i][j] = (i==j)? 1.0 : 0.0 ;
		}
	}
	
	for( pivot=0 ; pivot<size ; pivot++ ){	//pivot
		
		max = 0.0;
		for(i= pivot ; i<size ; i++ ){
			if( fabs(x[i][pivot]) > max ){
				max = fabs(x[i][pivot]);
				max_row = i;
			}
		}
		if( max == 0.0 ){
			printf("not exist\a\n");
			return -1;
		}
		if( pivot != max_row ){
			for( j=0; j<size ; j++ ){
				tmp = x[pivot][j];
				x[pivot][j] = x[max_row][j];
				x[max_row][j] = tmp;
				
				tmp = inv[pivot][j];
				inv[pivot][j] = inv[max_row][j];
				inv[max_row][j] = tmp;
				
			}
		}
		
		
		
		tmp = 1.0/x[pivot][pivot];
		for(j=0;j<size ; j++){
			x[pivot][j] *= tmp;
			inv[pivot][j] *= tmp;
		}
		
		
		for(i=0;i<size; i++){	//for1
			if( pivot != i ){
				tmp = x[i][pivot];
				for( j = 0 ; j < size ; j ++){
					x[i][j] -= x[pivot][j]*tmp;
					inv[i][j] -= inv[pivot][j]*tmp;
				}
			}
		}	//for1
		
	}	//pivot
	
	for( i=0 ;i<size ; i++){
		for(j=0; j<size ; j++ ){
			if( inv[i][j] > pow(10,5) ){
				printf("incredible\a\n");
				return -1;
			}
		}
	}
	
	
	return 1;
}


double average( double *x ){
	int t;
	double ave=0.0;
	for( t=0 ; t<Number ;t++){
		ave += x[t];
	}
	return (ave/Number);
}

double Variance(double *x , int num){
	double sum_x  = 0.0;
	double sum_xx = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_xx += x[i]*x[i];
	}
	return (sum_xx/num - pow(sum_x/num, 2));
}

double Covariance(double *x , double *y , int num){
	double sum_x  = 0.0;
	double sum_y  = 0.0;
	double sum_xy = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_y  += y[i];
		sum_xy += x[i] * y[i];
	}
	return ( sum_xy /num - (sum_x/num)*(sum_y/num) );
}

double Correlation( double *x , double *y , int num){
	double r;
	r = Covariance(x,y,num)/sqrt( Variance(x,num) * Variance(y,num));
	
	return r;
}



int main( int argc, char *argv[]){
	int i,j,k,t;
	double S[size][size];
	double inv[size][size];
	double T[size];
	double **x , *y , *tmp1,*tmp2;
	x = (double **) calloc( size , sizeof(double*) );
	y = (double *) calloc( Number , sizeof(double) );
	tmp1 = (double *) calloc( Number , sizeof(double) );
	tmp2 = (double *) calloc( Number , sizeof(double) );
	for(i=0;i<size;i++){
		x[i] = (double *)calloc( Number , sizeof(double) );
	}
	
	FILE *fpr,*fpw;
	char *fnr,*fnw;
	fnr = (char * )calloc( 100 , sizeof(char));
	fnw = (char * )calloc( 100 , sizeof(char));
	sprintf(fnr , "data_%s_%s.dat",argv[1],argv[2]);
	sprintf(fnw , "model1/output_%s_%s.dat",argv[1],argv[2]);
	fpr = fopen( fnr , "r" );
	fpw = fopen( fnw , "w" );

	
	double tmp;
	for(i=0;i<Number;i++){
		fscanf(fpr , "%lf	%lf	%lf	%lf",&x[0][i],&x[1][i],&tmp,&y[i]);
	}
	double sum_x, sum_y, sum_xy;
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			sum_x = 0.0;
			sum_y = 0.0;
			sum_xy = 0.0;
			for(t=0;t<Number;t++){
				sum_x  += x[i][t];
				sum_y  += x[j][t];
				sum_xy += x[i][t] * x[j][t];
			}
			S[i][j] = sum_xy /Number - (sum_x/Number)*(sum_y/Number);
		}
		sum_x = 0.0;
		sum_y = 0.0;
		sum_xy = 0.0;
		for(t=0;t<Number;t++){
			sum_x  += x[i][t];
			sum_y  += y[t];
			sum_xy += x[i][t] * y[t];
		}
		T[i] = sum_xy /Number - (sum_x/Number)*(sum_y/Number);
	}

	
	int check = matrix_inv( S, inv);
	double beta[size+1];
	for(i=0;i<size;i++)	beta[i] = 0.0;
	
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			beta[i+1] += inv[i][j] * T[j];
		}
	}
	for(t=0;t<Number;t++){
		beta[0] += y[t]/Number;
		for(i=0;i<size;i++)	beta[0] -= (x[i][t] * beta[i+1])/Number;
	}
	
	double error1 =0.0 , error2=0.0 , ave;
	double *yhat;
	yhat = (double *) calloc( Number , sizeof(double) );
	for(t=0;t<Number;t++){
		ave = 0.0;
		tmp = 0.0;
		for(i=0;i<=size;i++){
			if(i==0){
				yhat[t] += beta[i];
				tmp += beta[i];
			}
			else{
				yhat[t] += beta[i] * x[i-1][t];
				tmp += beta[i] * x[i-1][t];
			}
		}
		error1 += pow( y[t] - yhat[t] , 2 );
		
		for(i=0;i<Number;i++){
			ave += y[i]/Number;
		}
		
		error2 += pow( tmp - ave , 2 );
	
	}
	
	
	
	double tdis , sigma, sum=0.0;
	for(i=0;i<=size;i++){
		if(i==0){
			for(j=0;j<size;j++){
				for(k=0;k<size;k++){
					
					for(t=0;t<Number;t++){
						tmp1[t] = x[j][t];
						tmp2[t] = x[k][t];
					}
					sum += average( tmp1 ) * average( tmp2 )* inv[j][k]/Number;
				}
			}
			sigma = sqrt( error1 * (1.0/Number  + sum) / (Number-size-1)  );
			tdis = beta[0] / sigma;
			
		}
		else{
			sigma = sqrt( inv[i-1][i-1]/Number * error1 / (Number - size -1 ));
			tdis = beta[i]/sigma;
		}

		
		
		fprintf(fpw , "beta[%d]=%f	t=%f \n",i,beta[i],tdis);
	}
	fprintf(fpw,"\n");
	
	fprintf(fpw,"F = %f\n",(double)(Number-size-1)*error2 / (size * error1 ) );
	fprintf(fpw,"\n");
	
	
	fprintf(fpw,"R = %f\n", (double)((Number-1)*pow( Correlation( y , yhat , Number) ,2 )-size)/(Number-size-1)  );
	fprintf(fpw,"\n");
	
	fprintf(fpw,"AIC = %f\n",Number*log(2*M_PI*error1/Number) + Number + 2*(size+2) );
	
	fclose(fpr);
	fclose(fpw);
	free(fnr);
	free(fnw);
	free(y);
	free(tmp1);
	free(tmp2);
	free(yhat);
	for(i=0;i<size;i++)	free(x[i]);
	return 0;
}

